--- old/usr/src/tools/smatch/src/smatch_flow.c	Tue May 19 02:50:33 2020
+++ new/usr/src/tools/smatch/src/smatch_flow.c	Tue May 19 02:50:33 2020
@@ -438,20 +438,20 @@
 
 		/* foo = !bar() */
 		if (__handle_condition_assigns(expr))
-			break;
+			goto after_assign;
 		/* foo = (x < 5 ? foo : 5); */
 		if (__handle_select_assigns(expr))
-			break;
+			goto after_assign;
 		/* foo = ({frob(); frob(); frob(); 1;}) */
 		if (__handle_expr_statement_assigns(expr))
-			break;
+			break;  // FIXME: got after
 		/* foo = (3, 4); */
 		if (handle_comma_assigns(expr))
-			break;
-		if (handle_postop_assigns(expr))
-			break;
+			goto after_assign;
 		if (handle__builtin_choose_expr_assigns(expr))
-			break;
+			goto after_assign;
+		if (handle_postop_assigns(expr))
+			break;  /* no need to goto after_assign */
 
 		__split_expr(expr->right);
 		if (outside_of_function())
@@ -470,8 +470,8 @@
 		    get_macro_name(expr->pos) != get_macro_name(right->pos))
 			__pass_to_client(expr, MACRO_ASSIGNMENT_HOOK);
 
+after_assign:
 		__pass_to_client(expr, ASSIGNMENT_HOOK_AFTER);
-
 		__split_expr(expr->left);
 		break;
 	}
